package com.muzhi.lz.controller;


import com.muzhi.lz.entity.EmployeeLz;
import com.muzhi.lz.entity.EmployeeLzLizhi;
import com.muzhi.lz.service.TongbuService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Api(description = "同步数据至数据库")
@RestController
@RequestMapping("/tongbuservice/tongbu")
@CrossOrigin//解决跨域问题
public class TongbuController {

    @Autowired
    private TongbuService tongbuService;

    //查询数据库中employee_lz表的所有数据
    @ApiOperation(value = "查询数据库中employee_lz表的所有数据")
    @GetMapping("getEmployeeLz")
    public List<EmployeeLz> getEmployeeLz(){
        List<EmployeeLz> employeeLz = tongbuService.getEmployeeLz();
        return employeeLz;
    }

    //删除employee_lz表中的所有数据
    @ApiOperation(value = "删除employee表中的所有数据")
    @PostMapping("removeEmployeeLz")
    public String removeEmployeeLz(){
        String result = tongbuService.removeEmployeeLz();
        return result;
    }

    //同步花名册数据至数据库（***在职人员***）
    @ApiOperation(value = "同步花名册数据至数据库（***在职人员***）")
    @PostMapping("addHuamingceLz")
//    @Scheduled(cron = "0 0 12 * * ?")//每天中午12：00触发（也就是中午12点整触发）
    @Scheduled(cron = "0 0 0 * * ?")//每天00：00触发（也就是凌晨0点整触发）
    public String addHuamingceLz(){
        //【***在职人员信息/入职人员信息***】
        //先删除清空employee_lz_copy表中的所有数据（初次同步表）
        tongbuService.removeEmployeeLzCopy();

        //再执行插入花名册数据库表的接口
        String result = tongbuService.addHuamingceLz();


        //【***入职人员信息***】


        //TODO 临时测试放在一起执行
        //【***离职人员信息***】
        //先删除清空employee_lz_lizhi_copy表中的所有数据（初次同步表）
        tongbuService.removeEmployeeLzLizhiCopy();

        //再执行插入花名册数据库表的接口
        String result1 = tongbuService.addHuamingceLzLizhi();

        return result;
    }



    //查询数据库中employee_lz_lizhi表的所有数据
    @ApiOperation(value = "查询数据库中employee_lz_lizhi表的所有数据")
    @GetMapping("getEmployeeLzLizhi")
    public List<EmployeeLzLizhi> getEmployeeLzLizhi(){
        List<EmployeeLzLizhi> employeeLzLizhi = tongbuService.getEmployeeLzLizhi();
        return employeeLzLizhi;
    }

    //删除employee_lz_lizhi表中的所有数据
    @ApiOperation(value = "删除employee_lz_lizhi表中的所有数据")
    @PostMapping("removeEmployeeLzLizhi")
    public String removeEmployeeLzLizhi(){
        String removeEmployeeLzLizhi = tongbuService.removeEmployeeLzLizhi();
        return removeEmployeeLzLizhi;
    }

    //同步花名册数据至数据库（***离职人员***）
    @ApiOperation(value = "同步花名册数据至数据库（***离职人员***）")
    @PostMapping("addHuamingceLzLizhi")
//    @Scheduled(cron = "0 1 15 * * ?")//每天下午15：01触发（也就是下午3点触发）
//    @Scheduled(cron = "0 0 0 * * ?")//每天00：00触发（也就是凌晨0点整触发）
    public String addHuamingceLzLizhi(){
        //先删除清空employee_lz_lizhi_copy表中的所有数据
        tongbuService.removeEmployeeLzLizhiCopy();

        //再执行插入花名册数据库表的接口
        String result = tongbuService.addHuamingceLzLizhi();
        return result;
    }


    @ApiOperation(value = "测试定时器定时执行")
    @PostMapping("dingshi")
//    @Scheduled(cron = "0 11 14 * * ?")//每天下午14：11触发
//    @Scheduled(cron = "0 12 14 * * ?")//每天下午14：12触发
//    @Scheduled(cron = "0 13 14 * * ?")//每天下午14：13触发
//    @Scheduled(cron = "0 14 14 * * ?")//每天下午14：14触发
    public String dingshi(){
        System.out.println("定时器执行中···");

        return null;
    }
}
