package com.muzhi.lz.service.impl;

import com.auth0.jwt.JWT;
import com.auth0.jwt.algorithms.Algorithm;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.request.OapiGettokenRequest;
import com.dingtalk.api.response.OapiGettokenResponse;
import com.muzhi.lz.service.DingAccessTokenService;
import com.taobao.api.ApiException;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.Date;


/**
 * @Author ZhangKan
 * @Data 15:39
 */

@Service
public class DingAccessTokenServiceImpl implements DingAccessTokenService{
    //DingAccessTokenService

    //律政
    //APPKEY
    private static String APPKEY = "dingibdhs7hjvgokudzc";
    //APPSECRET
    private static String APPSECRET = "yl1hIHSTprJ-F2KZf7pbJimvOAGJMifc0PCZxQ_ihpoRGFAJu7Yazw4sTZzXjMre";

    public static String accessToken = null;


    //牧之测试架构4
    //APPKEY
    private static String APPKEY1 = "ding2katvzyqvlkunqtb";
    //APPSECRET
    private static String APPSECRET1 = "vSctQrVm5cGos0X6K86NN0A8Vv6-SmN4W_VRXjsqPqZRhZtbG6xfPATOZhPi3VBE";

    public static String accessToken1 = null;

    //获取access_token的方法（律政）
    @Override
    public String getAccessToken() {
        DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/gettoken");
        OapiGettokenRequest request = new OapiGettokenRequest();
        request.setAppkey(APPKEY);
        request.setAppsecret(APPSECRET);
        request.setHttpMethod("GET");
        try {
            OapiGettokenResponse response = client.execute(request);
            accessToken = response.getAccessToken();
            System.out.println("律政AccessToken：" + accessToken);
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return accessToken;
    }

    //获取access_token的方法（牧之测试架构4）
    @Override
    public String getMuZhiAccessToken() {
        DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/gettoken");
        OapiGettokenRequest request = new OapiGettokenRequest();
        request.setAppkey(APPKEY1);
        request.setAppsecret(APPSECRET1);
        request.setHttpMethod("GET");
        try {
            OapiGettokenResponse response = client.execute(request);
            accessToken1 = response.getAccessToken();
            System.out.println("牧之测试架构4的AccessToken：" + accessToken1);
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return accessToken1;
    }


    public static final Long   EXPIRES_IN = 1 * 3600 * 1000L;
    public static final String TOKEN_APPID = "_appId";

    public static String appId = "61973fb4de120838cc3903e1";
    public static String appSecret = "zw9rcYZSlHBvpGdGtVxzxeF5ynKg6oAg";
    //获取access_token的方法（TB应用）
    @Override
    public String getAppToken() {
        if (StringUtils.isEmpty(appId) || StringUtils.isEmpty(appSecret)) {
            return null;
        }

        Algorithm algorithm = Algorithm.HMAC256(appSecret);
        long timestamp = System.currentTimeMillis();
        Date issuedAt = new Date(timestamp);
        Date expiresAt = new Date(timestamp + EXPIRES_IN);

//        return JWT.create()
//                .withClaim(TOKEN_APPID, appId)
//                .withIssuedAt(issuedAt)
//                .withExpiresAt(expiresAt)
//                .sign(algorithm);

        String sign = JWT.create()
                .withClaim(TOKEN_APPID, appId)
                .withIssuedAt(issuedAt)
                .withExpiresAt(expiresAt)
                .sign(algorithm);
        System.out.println("TB应用的AccessToken：" + sign);

        return sign;

    }

}
