package com.muzhi.lz.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.*;
import com.dingtalk.api.response.*;
import com.muzhi.lz.entity.*;
import com.muzhi.lz.mapper.*;
import com.muzhi.lz.service.DingAccessTokenService;
import com.muzhi.lz.service.TongbuService;
import com.taobao.api.ApiException;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


@Service
public class TongbuServiceImpl implements TongbuService{

    @Autowired
    private DingAccessTokenService dingAccessTokenService;


    //律政在职人员
    @Autowired
    private EmployeeLzMapper employeeLzMapper;
    @Autowired
    private EmployeeLzCopyMapper employeeLzCopyMapper;

    //律政入职人员
    @Autowired
    private EmployeeLzRuzhiMapper employeeLzRuzhiMapper;
    @Autowired
    private EmployeeLzRuzhiCopyMapper employeeLzRuzhiCopyMapper;

    //律政离职人员
    @Autowired
    private EmployeeLzLizhiMapper employeeLzLizhiMapper;
    @Autowired
    private EmployeeLzLizhiCopyMapper employeeLzLizhiCopyMapper;


    public static String huamingce = null;
    public static String huamingce2 = null;

    public static String employee1 = null;
    public static String employee2 = null;

    //查询数据库中employee_lz表的所有数据
    @Override
    public List<EmployeeLz> getEmployeeLz(){
        List<EmployeeLz> employeeList = employeeLzMapper.selectList(null);
        return employeeList;
    }

    //删除employee_lz表中的所有数据
    @Override
    public String removeEmployeeLz(){
        employeeLzMapper.delete(null);
        return "清空employee_lz数据成功！";
    }

    //删除employee_lz_copy表中的所有数据
    @Override
    public String removeEmployeeLzCopy(){
        employeeLzCopyMapper.delete(null);
        return "清空employee_lz_copy数据成功！";
    }



    //删除employee_lz_ruzhi表中的所有数据
    @Override
    public String removeEmployeeLzRuzhi(){
        employeeLzRuzhiMapper.delete(null);
        return "清空employee_lz_ruzhi数据成功！";
    }

    //删除employee_lz_ruzhi_copy表中的所有数据
    @Override
    public String removeEmployeeLzRuzhiCopy(){
        employeeLzRuzhiCopyMapper.delete(null);
        return "清空employee_lz_ruzhi_copy数据成功！";
    }



    //同步花名册数据至数据库（***在职人员***）
    @Override
    public String addHuamingceLz(){

        //在职员工id列表的循环获取
        DingTalkClient client1 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/queryonjob");
        OapiSmartworkHrmEmployeeQueryonjobRequest request1 = new OapiSmartworkHrmEmployeeQueryonjobRequest();

        //企业在职员工userid列表
        int offset = 0;//分页游标，从0开始
        int size = 50;//分页大小，最大50


        JSONObject result1;

        do {
            List<String> list = new ArrayList<>();

            System.out.println("测试分页值：" + offset);

            try {
                request1.setStatusList("2,3,5,-1");
                request1.setOffset((long) offset);
                request1.setSize((long) size);
                OapiSmartworkHrmEmployeeQueryonjobResponse response1 = client1.execute(request1, dingAccessTokenService.getAccessToken());
                employee1 = response1.getBody();
                System.out.println(response1.getBody());
            } catch (ApiException e) {
                e.printStackTrace();
            }

            //通过fastjson工具转换成json对象,逐层解析
            JSONObject jsonObject1 = JSON.parseObject(employee1);
            result1 = jsonObject1.getJSONObject("result");

            String dataList = result1.getString("data_list");

            //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
            String dataRes = dataList.replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");

            list.add(dataRes);

            String userid1 = list.toString().replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");


            //TODO ---原始同步花名册数据至数据库--- //
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/list");
            OapiSmartworkHrmEmployeeListRequest request = new OapiSmartworkHrmEmployeeListRequest();

            try {
                request.setUseridList(userid1);

                //需要获取的花名册字段信息
                //request.setFieldFilterList("sys00-name,sys02-sexType,sys01-employeeStatus,sys00-email,sys03-graduateSchool,sys03-highestEdu,sys00-dept,e3d6dbbd-9265-4f1e-8c58-ac3602e83960,sys03-graduationTime,sys00-mobile,sys02-address,sys02-marriage,sys00-confirmJoinTime,sys00-workPlace,sys00-position,sys01-positionLevel,sys02-politicalStatus,sys03-major,sys02-certNo,sys02-birthTime,sys02-certAddress,sys02-certEndTime,sys02-residenceType,sys01-employeeType,sys04-bankAccountNo,sys04-accountBank,sys09-personalHf,sys05-contractType,sys05-contractCompanyName,ff63191a-45cf-4106-ade0-54f1def7cc55");

                OapiSmartworkHrmEmployeeListResponse response = client.execute(request, dingAccessTokenService.getAccessToken());
                huamingce = response.getBody();
                System.out.println(response.getBody());
            }catch (ApiException e){
                e.printStackTrace();
            }

            //通过fastjson工具转换成json对象,逐层解析
            //将String类型的花名册json数据转换为Object数据对象
            JSONObject jsonObject = JSON.parseObject(huamingce);

            //直接将花名册对象通过Object转换成Array数组格式
            JSONArray resultArray = jsonObject.getJSONArray("result");

            //new一个employee对象
            EmployeeLzCopy employeeLzCopy = new EmployeeLzCopy();
            //入职表
            EmployeeLzRuzhiCopy employeeLzRuzhiCopy = new EmployeeLzRuzhiCopy();

            for (int i = 0; i<resultArray.size(); i++){
                JSONArray fieldListArray = resultArray
                        .getJSONObject(i).getJSONArray("field_list");

                String userid = resultArray.getJSONObject(i).getString("userid");
                System.out.println("员工id：" + userid);


                /*判断数据库入职表中是否存在该人员的id*/
//                String id111 = null;
                Integer id111 = 0;
                try {
                    QueryWrapper<EmployeeLzRuzhiCopy> queryWrapper = new QueryWrapper<>();
                    queryWrapper.select("id").eq("id", userid);

                    Integer integer = employeeLzRuzhiCopyMapper.selectCount(queryWrapper);
                    System.out.println("查询当前人员的id在数据库中是否存在，返回数据条数：" + integer);
//                id111 = employeeLzRuzhiCopy1.getId();
                    id111 = integer;
                    System.out.println("查询数据库入职表中的存在人员的id条数：" + id111);
                }catch (Exception e){
                    e.printStackTrace();
                }
                /*判断数据库入职表中是否存在该人员的id*/

                //【***如果入职首次同步表中不存在律政架构中当前循环的该人员id，将该部门及人员信息插入当前的入职copy表***】
                if (id111==null || id111==0){
                    System.out.println("数据库不存在该人员，插入！");
                }else {
                    System.out.println("数据库中该人员已存在，不执行任何操作！");
                }


                /*根据用户id查询部门名称，并分别同步多条数据至数据库*/
                //***获取指定用户的所有父部门列表
                String bumen111 = null;
                try {
                    DingTalkClient client111 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/listparentbyuser");
                    OapiV2DepartmentListparentbyuserRequest req111 = new OapiV2DepartmentListparentbyuserRequest();

                    //传入用户id
                    req111.setUserid(userid);

                    OapiV2DepartmentListparentbyuserResponse rsp111 = client111.execute(req111, dingAccessTokenService.getAccessToken());
                    bumen111 = rsp111.getBody();
                    System.out.println(rsp111.getBody());
                } catch (ApiException e) {
                    e.printStackTrace();
                }

                JSONObject jsonObject111;
                JSONObject result111;
                JSONArray parent_list;

                try {
                    jsonObject111 = JSON.parseObject(bumen111);
                    result111 = jsonObject111.getJSONObject("result");
                    parent_list = result111.getJSONArray("parent_list");
                    System.out.println("初步解析处理：" + parent_list);


                for (int a1 = 0; a1<parent_list.size(); a1++){
                    JSONArray parent_dept_id_list = parent_list.getJSONObject(a1).getJSONArray("parent_dept_id_list");
                    System.out.println("多部门列表解析：" + parent_dept_id_list);

                    //获取部门详情（主要用于获取部门名称）
                    String bmid111 = null;
                    String bmid222 = null;
                    String bmid333 = null;
                    String bmid444 = null;
                    String bmid555 = null;
                    String bmid666 = null;
                    String bmid777 = null;
                    String bmid888 = null;
                    String bmid999 = null;

                    long bmid1111 = 0;
                    long bmid2222 = 0;
                    long bmid3333 = 0;
                    long bmid4444 = 0;
                    long bmid5555 = 0;
                    long bmid6666 = 0;
                    long bmid7777 = 0;
                    long bmid8888 = 0;
                    long bmid9999 = 0;

                    //每个部门分组的部门id共有几个
                    int xx = parent_dept_id_list.size();

                    //倒叙查询主部门及下级各部门
                    try {
                        bmid111 = parent_dept_id_list.getString(xx-1);
                        System.out.println("第一个！！！！！！！！！！！！！！！！！" + bmid111);
                        bmid222 = parent_dept_id_list.getString(xx-2);
                        System.out.println("第二个！！！！！！！！！！！！！！！！！" + bmid222);
                        bmid333 = parent_dept_id_list.getString(xx-3);
                        System.out.println("第三个！！！！！！！！！！！！！！！！！" + bmid333);
                        bmid444 = parent_dept_id_list.getString(xx-4);
                        System.out.println("第四个！！！！！！！！！！！！！！！！！" + bmid444);
                        bmid555 = parent_dept_id_list.getString(xx-5);
                        System.out.println("第五个！！！！！！！！！！！！！！！！！" + bmid555);
                        bmid666 = parent_dept_id_list.getString(xx-6);
                        System.out.println("第六个！！！！！！！！！！！！！！！！！" + bmid666);
                        bmid777 = parent_dept_id_list.getString(xx-7);
                        System.out.println("第七个！！！！！！！！！！！！！！！！！" + bmid777);
                        bmid888 = parent_dept_id_list.getString(xx-8);
                        System.out.println("第八个！！！！！！！！！！！！！！！！！" + bmid888);
                        bmid999 = parent_dept_id_list.getString(xx-9);
                        System.out.println("第九个！！！！！！！！！！！！！！！！！" + bmid999);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    try {
                        bmid1111 = Long.parseLong(bmid111);
                        System.out.println("最终解析的每个独立的部门id1：" + bmid1111);
                        bmid2222 = Long.parseLong(bmid222);
                        System.out.println("最终解析的每个独立的部门id2：" + bmid2222);
                        bmid3333 = Long.parseLong(bmid333);
                        System.out.println("最终解析的每个独立的部门id3：" + bmid3333);
                        bmid4444 = Long.parseLong(bmid444);
                        System.out.println("最终解析的每个独立的部门id4：" + bmid4444);
                        bmid5555 = Long.parseLong(bmid555);
                        System.out.println("最终解析的每个独立的部门id5：" + bmid5555);
                        bmid6666 = Long.parseLong(bmid666);
                        System.out.println("最终解析的每个独立的部门id6：" + bmid6666);
                        bmid7777 = Long.parseLong(bmid777);
                        System.out.println("最终解析的每个独立的部门id7：" + bmid7777);
                        bmid8888 = Long.parseLong(bmid888);
                        System.out.println("最终解析的每个独立的部门id8：" + bmid8888);
                        bmid9999 = Long.parseLong(bmid999);
                        System.out.println("最终解析的每个独立的部门id9：" + bmid9999);
                    }catch (Exception e){
                        e.printStackTrace();
                    }


                    String bumenXQ1 = null;
                    String bumenXQ2 = null;
                    String bumenXQ3 = null;
                    String bumenXQ4 = null;
                    String bumenXQ5 = null;
                    String bumenXQ6 = null;
                    String bumenXQ7 = null;
                    String bumenXQ8 = null;
                    String bumenXQ9 = null;

                    String BMname1 = null;
                    String BMname2 = null;
                    String BMname3 = null;
                    String BMname4 = null;
                    String BMname5 = null;
                    String BMname6 = null;
                    String BMname7 = null;
                    String BMname8 = null;
                    String BMname9 = null;


                    /*👇👇👇👇👇👇另一种写法，优化方案，待测试👇👇👇👇👇👇*/
//                    for (int x = 0; x < 9; x++){
//                        String bmidx = parent_dept_id_list.getString(x);
//                        long bmidxx = Long.parseLong(bmidx);
//                        try {
//                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
//                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();
//
//                            //部门id
//                            req222.setDeptId(bmidxx);
//
//                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
//                            bumenXQ1 = rsp222.getBody();
//                            System.out.println(rsp222.getBody());
//                        } catch (ApiException e) {
//                            e.printStackTrace();
//                        }
//
//                        //解析出来部门名称
//                        JSONObject jsonObject222 = null;
//                        JSONObject result222 = null;
//                        String BMnamex = null;
//
//                        try {
//                            jsonObject222 = JSON.parseObject(bumenXQ1);
//                            System.out.println("初步解析处理（部门1详情）：" + jsonObject222);
//
//                            result222 = jsonObject222.getJSONObject("result");
//                            BMnamex = result222.getString("name");
//                            System.out.println("部门1名称：" + BMnamex);
//                        }catch (Exception e){
//                            e.printStackTrace();
//                        }
//
//                        if (x==0){
//                            employeeLz.setBmid9(bmidx);
//                            employeeLz.setBmmc9(BMnamex);
//                        }else if (x==1){
//                            employeeLz.setBmid8(bmidx);
//                            employeeLz.setBmmc8(BMnamex);
//                        }else if (x==2){
//                            employeeLz.setBmid7(bmidx);
//                            employeeLz.setBmmc7(BMnamex);
//                        }else if (x==3){
//                            employeeLz.setBmid6(bmidx);
//                            employeeLz.setBmmc6(BMnamex);
//                        }else if (x==4){
//                            employeeLz.setBmid5(bmidx);
//                            employeeLz.setBmmc5(BMnamex);
//                        }else if (x==5){
//                            employeeLz.setBmid4(bmidx);
//                            employeeLz.setBmmc4(BMnamex);
//                        }else if (x==6){
//                            employeeLz.setBmid3(bmidx);
//                            employeeLz.setBmmc3(BMnamex);
//                        }else if (x==7){
//                            employeeLz.setBmid2(bmidx);
//                            employeeLz.setBmmc2(BMnamex);
//                        }else if (x==8){
//                            employeeLz.setBmid1(bmidx);
//                            employeeLz.setBmmc1(BMnamex);
//                        }
//                    }
                    /*👆👆👆👆👆👆另一种写法，优化方案，待测试👆👆👆👆👆👆*/


                    System.out.println("bmid111：" + bmid111);
                    System.out.println("bmid1111：" + bmid1111);
                    if (bmid111 != null) {
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid1111);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ1 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ1);
                        System.out.println("初步解析处理（部门1详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname1 = result222.getString("name");
                        System.out.println("部门1名称：" + BMname1);
                    }else{
                        BMname1 = "上海律正企业管理有限公司";
                    }

                    System.out.println("bmid222：" + bmid222);
                    System.out.println("bmid2222：" + bmid2222);
                    if (bmid222 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid2222);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ2 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ2);
                        System.out.println("初步解析处理（部门2详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname2 = result222.getString("name");
                        System.out.println("部门2名称：" + BMname2);
                    }else{
                        BMname2 = "-";
                    }

                    System.out.println("bmid333：" + bmid333);
                    System.out.println("bmid3333：" + bmid3333);
                    if (bmid333 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid3333);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ3 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ3);
                        System.out.println("初步解析处理（部门3详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname3 = result222.getString("name");
                        System.out.println("部门3名称：" + BMname3);
                    }else{
                        BMname3 = "-";
                    }

                    System.out.println("bmid444：" + bmid444);
                    System.out.println("bmid4444：" + bmid4444);
                    if (bmid444 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid4444);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ4 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ4);
                        System.out.println("初步解析处理（部门4详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname4 = result222.getString("name");
                        System.out.println("部门4名称：" + BMname4);
                    }else{
                        BMname4 = "-";
                    }

                    System.out.println("bmid555：" + bmid555);
                    System.out.println("bmid5555：" + bmid5555);
                    if (bmid555 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid5555);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ5 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ5);
                        System.out.println("初步解析处理（部门5详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname5 = result222.getString("name");
                        System.out.println("部门5名称：" + BMname5);
                    }else{
                        BMname5 = "-";
                    }

                    System.out.println("bmid666：" + bmid666);
                    System.out.println("bmid6666：" + bmid6666);
                    if (bmid666 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid6666);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ6 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ6);
                        System.out.println("初步解析处理（部门6详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname6 = result222.getString("name");
                        System.out.println("部门6名称：" + BMname6);
                    }else{
                        BMname6 = "-";
                    }

                    System.out.println("bmid777：" + bmid777);
                    System.out.println("bmid7777：" + bmid7777);
                    if (bmid777 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid7777);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ7 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ7);
                        System.out.println("初步解析处理（部门7详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname7 = result222.getString("name");
                        System.out.println("部门7名称：" + BMname7);
                    }else{
                        BMname7 = "-";
                    }

                    System.out.println("bmid888：" + bmid888);
                    System.out.println("bmid8888：" + bmid8888);
                    if (bmid888 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid8888);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ8 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ8);
                        System.out.println("初步解析处理（部门8详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname8 = result222.getString("name");
                        System.out.println("部门8名称：" + BMname8);
                    }else{
                        BMname8 = "-";
                    }

                    System.out.println("bmid999：" + bmid999);
                    System.out.println("bmid9999：" + bmid9999);
                    if (bmid999 != null){
                        try {
                            DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                            OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                            //部门id
                            req222.setDeptId(bmid9999);

                            OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                            bumenXQ9 = rsp222.getBody();
                            System.out.println(rsp222.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        //解析出来部门名称
                        JSONObject jsonObject222 = JSON.parseObject(bumenXQ9);
                        System.out.println("初步解析处理（部门9详情）：" + jsonObject222);

                        JSONObject result222 = jsonObject222.getJSONObject("result");
                        BMname9 = result222.getString("name");
                        System.out.println("部门9名称：" + BMname9);
                    }else{
                        BMname9 = "-";
                    }


                    //【***如果入职首次同步表中不存在律政架构中当前循环的该人员id，将该部门及人员信息插入当前的入职copy表***】
                    if (id111==null || id111==0){
                        System.out.println("数据库不存在该人员，插入！");

                        //TODO 每组部门id都插入一条员工信息到数据库
                        //将result的每个对象的id放入employee实体类的id字段中
                        employeeLzRuzhiCopy.setId(userid);

                        //TODO 循环插入部门分组不同层级的部门到数据库各个部门层级字段中
                        employeeLzRuzhiCopy.setBmid1("1");
                        employeeLzRuzhiCopy.setBmmc1(BMname1);

                        employeeLzRuzhiCopy.setBmid2(bmid222);
                        employeeLzRuzhiCopy.setBmmc2(BMname2);

                        employeeLzRuzhiCopy.setBmid3(bmid333);
                        employeeLzRuzhiCopy.setBmmc3(BMname3);

                        employeeLzRuzhiCopy.setBmid4(bmid444);
                        employeeLzRuzhiCopy.setBmmc4(BMname4);

                        employeeLzRuzhiCopy.setBmid5(bmid555);
                        employeeLzRuzhiCopy.setBmmc5(BMname5);

                        employeeLzRuzhiCopy.setBmid6(bmid666);
                        employeeLzRuzhiCopy.setBmmc6(BMname6);

                        employeeLzRuzhiCopy.setBmid7(bmid777);
                        employeeLzRuzhiCopy.setBmmc7(BMname7);

                        employeeLzRuzhiCopy.setBmid8(bmid888);
                        employeeLzRuzhiCopy.setBmmc8(BMname8);

                        employeeLzRuzhiCopy.setBmid9(bmid999);
                        employeeLzRuzhiCopy.setBmmc9(BMname9);

                        for (int a = 0; a < fieldListArray.size(); a++) {
                            String fieldCode = fieldListArray
                                    .getJSONObject(a)
                                    .getString("field_code");

                            switch (fieldCode) {
                                //姓名
                                case "sys00-name":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***《《《姓名》》》***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        //放入employee表的姓名字段中
                                        employeeLzRuzhiCopy.setSys00Name(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        //如果没有则放入空值
                                        employeeLzRuzhiCopy.setSys00Name("");
                                    }
                                    break;

                                //入职时间
                                case "sys00-confirmJoinTime":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***入职时间***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setSys00ConfirmJoinTime(fieldListArray.getJSONObject(a).getDate("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setSys00ConfirmJoinTime(null);
                                    }
                                    break;

                                //职位
                                case "sys00-position":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***职位***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setSys00Position(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setSys00Position("");
                                    }
                                    break;

                                //性别
                                case "sys02-sexType":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***性别***-->" + fieldListArray.getJSONObject(a).getString("value"));
//                            String sex = fieldListArray.getJSONObject(a).getInteger("value") == 0 ?"男":"女";
//                            employee.setSys02SexType(sex);
                                        employeeLzRuzhiCopy.setSys02SexType(fieldListArray.getJSONObject(a).getInteger("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setSys02SexType(null);
                                    }
                                    break;

                                //员工类型
                                case "sys01-employeeType":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***员工类型***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setSys01EmployeeType(fieldListArray.getJSONObject(a).getInteger("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setSys01EmployeeType(null);
                                    }
                                    break;

                                //员工状态
                                case "sys01-employeeStatus":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***员工状态***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setSys01EmployeeStatus(fieldListArray.getJSONObject(a).getInteger("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setSys01EmployeeStatus(null);
                                    }
                                    break;

                                    //***新增展示字段***
                                //入职渠道
                                case "89d91b67-dbae-4439-b451-abb73281b47b":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***入职渠道***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setRuzhiqudao(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setRuzhiqudao(null);
                                    }
                                    break;

                                //内荐人
                                case "203117a1-c8e1-4847-a6a9-292630f51c1c":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***内荐人***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setNeijianren(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setNeijianren(null);
                                    }
                                    break;

                                //直属主管
                                case "sys00-reportManager":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***直属主管***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzRuzhiCopy.setZhishuzhuguan(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzRuzhiCopy.setZhishuzhuguan(null);
                                    }
                                    break;
                            }
                        }
                        employeeLzRuzhiCopyMapper.insert(employeeLzRuzhiCopy);
                    }else {
                        System.out.println("数据库中该人员已存在，不执行任何操作！");
                    }


                    //TODO 每组部门id都插入一条员工信息到数据库
                    //将result的每个对象的id放入employee实体类的id字段中
                    employeeLzCopy.setId(userid);

                    //TODO 循环插入部门分组不同层级的部门到数据库各个部门层级字段中
                    employeeLzCopy.setBmid1("1");
                    employeeLzCopy.setBmmc1(BMname1);

                    employeeLzCopy.setBmid2(bmid222);
                    employeeLzCopy.setBmmc2(BMname2);

                    employeeLzCopy.setBmid3(bmid333);
                    employeeLzCopy.setBmmc3(BMname3);

                    employeeLzCopy.setBmid4(bmid444);
                    employeeLzCopy.setBmmc4(BMname4);

                    employeeLzCopy.setBmid5(bmid555);
                    employeeLzCopy.setBmmc5(BMname5);

                    employeeLzCopy.setBmid6(bmid666);
                    employeeLzCopy.setBmmc6(BMname6);

                    employeeLzCopy.setBmid7(bmid777);
                    employeeLzCopy.setBmmc7(BMname7);

                    employeeLzCopy.setBmid8(bmid888);
                    employeeLzCopy.setBmmc8(BMname8);

                    employeeLzCopy.setBmid9(bmid999);
                    employeeLzCopy.setBmmc9(BMname9);

                    for (int a = 0; a < fieldListArray.size(); a++) {
                        String fieldCode = fieldListArray
                                .getJSONObject(a)
                                .getString("field_code");

                        switch (fieldCode) {
                            //姓名
                            case "sys00-name":
                                if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                    System.out.println("***《《《姓名》》》***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                    //放入employee表的姓名字段中
                                    employeeLzCopy.setSys00Name(fieldListArray.getJSONObject(a).getString("value"));
                                } else {
                                    //如果没有则放入空值
                                    employeeLzCopy.setSys00Name("");
                                }
                                break;

                            //入职时间
                            case "sys00-confirmJoinTime":
                                if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                    System.out.println("***入职时间***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                    employeeLzCopy.setSys00ConfirmJoinTime(fieldListArray.getJSONObject(a).getDate("value"));
                                } else {
                                    employeeLzCopy.setSys00ConfirmJoinTime(null);
                                }
                                break;

                            //职位
                            case "sys00-position":
                                if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                    System.out.println("***职位***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                    employeeLzCopy.setSys00Position(fieldListArray.getJSONObject(a).getString("value"));
                                } else {
                                    employeeLzCopy.setSys00Position("");
                                }
                                break;

                            //性别
                            case "sys02-sexType":
                                if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                    System.out.println("***性别***-->" + fieldListArray.getJSONObject(a).getString("value"));
//                            String sex = fieldListArray.getJSONObject(a).getInteger("value") == 0 ?"男":"女";
//                            employee.setSys02SexType(sex);
                                    employeeLzCopy.setSys02SexType(fieldListArray.getJSONObject(a).getInteger("value"));
                                } else {
                                    employeeLzCopy.setSys02SexType(null);
                                }
                                break;

                            //员工类型
                            case "sys01-employeeType":
                                if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                    System.out.println("***员工类型***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                    employeeLzCopy.setSys01EmployeeType(fieldListArray.getJSONObject(a).getInteger("value"));
                                } else {
                                    employeeLzCopy.setSys01EmployeeType(null);
                                }
                                break;

                            //员工状态
                            case "sys01-employeeStatus":
                                if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                    System.out.println("***员工状态***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                    employeeLzCopy.setSys01EmployeeStatus(fieldListArray.getJSONObject(a).getInteger("value"));
                                } else {
                                    employeeLzCopy.setSys01EmployeeStatus(null);
                                }
                                break;
                        }
                    }
                    employeeLzCopyMapper.insert(employeeLzCopy);


                System.out.println("-------------------------分组分割线-------------------------");

                }
                /*根据用户id查询部门名称，并分别同步多条数据至数据库*/

                }catch (Exception e){
                    e.printStackTrace();
                }

            }


            if (result1.getString("next_cursor") != null || result1.getString("data_list") != "") {

                offset = offset + size;

            }

        } while (result1.getString("next_cursor") != null);



        //【***在职表***】
        //清空employee_lz最终展示表数据
        removeEmployeeLz();

        //TODO 将数据库中已经同步完成的employee_lz的数据1：1复制插入到另一张表中
        QueryWrapper<EmployeeLzCopy> employeeLzCopyQueryWrapper = new QueryWrapper<>();
        List<EmployeeLzCopy> employeeLzCopyList = employeeLzCopyMapper.selectList(employeeLzCopyQueryWrapper);
//        System.out.println("初步同步数据的表：employeeLzCopy" + employeeLzCopyList);

        //最终展示的表（待插入数据的表）
        EmployeeLz employeeLz = new EmployeeLz();

        //将有数据的表数据插入无数据的表对应的字段中
        for (int z = 0; z<employeeLzCopyList.size(); z++){
            employeeLz.setId(employeeLzCopyList.get(z).getId());
            employeeLz.setSys00Name(employeeLzCopyList.get(z).getSys00Name());
            employeeLz.setSys00ConfirmJoinTime(employeeLzCopyList.get(z).getSys00ConfirmJoinTime());
            employeeLz.setSys00Position(employeeLzCopyList.get(z).getSys00Position());
            employeeLz.setSys02SexType(employeeLzCopyList.get(z).getSys02SexType());
            employeeLz.setSys01EmployeeType(employeeLzCopyList.get(z).getSys01EmployeeType());
            employeeLz.setSys01EmployeeStatus(employeeLzCopyList.get(z).getSys01EmployeeStatus());

            employeeLz.setBmid1(employeeLzCopyList.get(z).getBmid1());
            employeeLz.setBmmc1(employeeLzCopyList.get(z).getBmmc1());

            employeeLz.setBmid2(employeeLzCopyList.get(z).getBmid2());
            employeeLz.setBmmc2(employeeLzCopyList.get(z).getBmmc2());

            employeeLz.setBmid3(employeeLzCopyList.get(z).getBmid3());
            employeeLz.setBmmc3(employeeLzCopyList.get(z).getBmmc3());

            employeeLz.setBmid4(employeeLzCopyList.get(z).getBmid4());
            employeeLz.setBmmc4(employeeLzCopyList.get(z).getBmmc4());

            employeeLz.setBmid5(employeeLzCopyList.get(z).getBmid5());
            employeeLz.setBmmc5(employeeLzCopyList.get(z).getBmmc5());

            employeeLz.setBmid6(employeeLzCopyList.get(z).getBmid6());
            employeeLz.setBmmc6(employeeLzCopyList.get(z).getBmmc6());

            employeeLz.setBmid7(employeeLzCopyList.get(z).getBmid7());
            employeeLz.setBmmc7(employeeLzCopyList.get(z).getBmmc7());

            employeeLz.setBmid8(employeeLzCopyList.get(z).getBmid8());
            employeeLz.setBmmc8(employeeLzCopyList.get(z).getBmmc8());

            employeeLz.setBmid9(employeeLzCopyList.get(z).getBmid9());
            employeeLz.setBmmc9(employeeLzCopyList.get(z).getBmmc9());

            employeeLzMapper.insert(employeeLz);
        }


        //【***入职表***】
        //清空employee_lz_ruzhi最终展示表数据
        removeEmployeeLzRuzhi();

        //TODO 将数据库中已经同步完成的employee_lz_ruzhi的数据1：1复制插入到另一张表中
        QueryWrapper<EmployeeLzRuzhiCopy> employeeLzRuzhiCopyQueryWrapper = new QueryWrapper<>();
        List<EmployeeLzRuzhiCopy> employeeLzRuzhiCopyList = employeeLzRuzhiCopyMapper.selectList(employeeLzRuzhiCopyQueryWrapper);

        //入职表
        EmployeeLzRuzhi employeeLzRuzhi = new EmployeeLzRuzhi();

        //将有数据的表数据插入无数据的表对应的字段中
        for (int z = 0; z<employeeLzRuzhiCopyList.size(); z++){
            employeeLzRuzhi.setId(employeeLzRuzhiCopyList.get(z).getId());
            employeeLzRuzhi.setSys00Name(employeeLzRuzhiCopyList.get(z).getSys00Name());
            employeeLzRuzhi.setSys00ConfirmJoinTime(employeeLzRuzhiCopyList.get(z).getSys00ConfirmJoinTime());
            employeeLzRuzhi.setSys00Position(employeeLzRuzhiCopyList.get(z).getSys00Position());
            employeeLzRuzhi.setSys02SexType(employeeLzRuzhiCopyList.get(z).getSys02SexType());
            employeeLzRuzhi.setSys01EmployeeType(employeeLzRuzhiCopyList.get(z).getSys01EmployeeType());
            employeeLzRuzhi.setSys01EmployeeStatus(employeeLzRuzhiCopyList.get(z).getSys01EmployeeStatus());

            //***新增展示字段***
            employeeLzRuzhi.setRuzhiqudao(employeeLzRuzhiCopyList.get(z).getRuzhiqudao());
            employeeLzRuzhi.setNeijianren(employeeLzRuzhiCopyList.get(z).getNeijianren());
            employeeLzRuzhi.setZhishuzhuguan(employeeLzRuzhiCopyList.get(z).getZhishuzhuguan());

            employeeLzRuzhi.setBmid1(employeeLzRuzhiCopyList.get(z).getBmid1());
            employeeLzRuzhi.setBmmc1(employeeLzRuzhiCopyList.get(z).getBmmc1());

            employeeLzRuzhi.setBmid2(employeeLzRuzhiCopyList.get(z).getBmid2());
            employeeLzRuzhi.setBmmc2(employeeLzRuzhiCopyList.get(z).getBmmc2());

            employeeLzRuzhi.setBmid3(employeeLzRuzhiCopyList.get(z).getBmid3());
            employeeLzRuzhi.setBmmc3(employeeLzRuzhiCopyList.get(z).getBmmc3());

            employeeLzRuzhi.setBmid4(employeeLzRuzhiCopyList.get(z).getBmid4());
            employeeLzRuzhi.setBmmc4(employeeLzRuzhiCopyList.get(z).getBmmc4());

            employeeLzRuzhi.setBmid5(employeeLzRuzhiCopyList.get(z).getBmid5());
            employeeLzRuzhi.setBmmc5(employeeLzRuzhiCopyList.get(z).getBmmc5());

            employeeLzRuzhi.setBmid6(employeeLzRuzhiCopyList.get(z).getBmid6());
            employeeLzRuzhi.setBmmc6(employeeLzRuzhiCopyList.get(z).getBmmc6());

            employeeLzRuzhi.setBmid7(employeeLzRuzhiCopyList.get(z).getBmid7());
            employeeLzRuzhi.setBmmc7(employeeLzRuzhiCopyList.get(z).getBmmc7());

            employeeLzRuzhi.setBmid8(employeeLzRuzhiCopyList.get(z).getBmid8());
            employeeLzRuzhi.setBmmc8(employeeLzRuzhiCopyList.get(z).getBmmc8());

            employeeLzRuzhi.setBmid9(employeeLzRuzhiCopyList.get(z).getBmid9());
            employeeLzRuzhi.setBmmc9(employeeLzRuzhiCopyList.get(z).getBmmc9());

            employeeLzRuzhiMapper.insert(employeeLzRuzhi);
        }



        return "同步律政【在职/入职/离职数据】成功！";
    }



    //查询数据库中employee_lz_lizhi表的所有数据
    @Override
    public List<EmployeeLzLizhi> getEmployeeLzLizhi(){
        List<EmployeeLzLizhi> employeeLzLizhi = employeeLzLizhiMapper.selectList(null);
        return employeeLzLizhi;
    }

    //删除employee_lz_lizhi表中的所有数据
    @Override
    public String removeEmployeeLzLizhi(){
        employeeLzLizhiMapper.delete(null);
        return "清空employee_lz_lizhi数据成功！";
    }

    //删除employee_lz_lizhi_copy表中的所有数据
    @Override
    public String removeEmployeeLzLizhiCopy(){
        employeeLzLizhiCopyMapper.delete(null);
        return "清空employee_lz_lizhi_copy数据成功！";
    }

    //同步花名册数据至数据库（***离职人员***）
    @Override
    public String addHuamingceLzLizhi(){

        //---*** 执行同步离职员工信息 ***---//
        //---*** 执行同步离职员工信息 ***---//
        //---*** 执行同步离职员工信息 ***---//

        //离职员工id列表的循环获取
        DingTalkClient client1 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/querydimission");
        OapiSmartworkHrmEmployeeQuerydimissionRequest request1 = new OapiSmartworkHrmEmployeeQuerydimissionRequest();

        //企业在职员工userid列表
        int offset = 0;//分页游标，从0开始
        int size = 50;//分页大小，最大50

        JSONObject result1;

        do {
            List<String> list = new ArrayList<>();

            System.out.println("测试分页值：" + offset);

            try {
                request1.setOffset((long) offset);
                request1.setSize((long) size);
                OapiSmartworkHrmEmployeeQuerydimissionResponse response = client1.execute(request1, dingAccessTokenService.getAccessToken());
                employee2 = response.getBody();
                System.out.println(response.getBody());
            } catch (ApiException e) {
                e.printStackTrace();
            }

            //通过fastjson工具转换成json对象,逐层解析
            JSONObject jsonObject1 = JSON.parseObject(employee2);
            result1 = jsonObject1.getJSONObject("result");

            String dataList = result1.getString("data_list");

            //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
            String dataRes = dataList.replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");

            list.add(dataRes);

            String userid1 = list.toString().replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");


            //TODO ---原始同步花名册数据至数据库--- //
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/list");
            OapiSmartworkHrmEmployeeListRequest request = new OapiSmartworkHrmEmployeeListRequest();

            try {
                request.setUseridList(userid1);

                //需要获取的花名册字段信息
//                request.setFieldFilterList("sys00-name,145d3425-9dea-42a6-88ae-1e4e3590046c,473f9667-d220-426f-8431-56be1e8a027d," +
//                        "395840c1-2cbe-4f36-b3fb-249d7ddf42f2,sys00-confirmJoinTime,sys02-sexType,sys02-certNo,sys01-employeeType," +
//                        "sys04-accountBank,sys04-bankAccountNo,ed21c116-efcb-49f3-a507-f8474450260c,sys01-employeeStatus");

                OapiSmartworkHrmEmployeeListResponse response = client.execute(request, dingAccessTokenService.getAccessToken());
                huamingce2 = response.getBody();
                System.out.println(response.getBody());
            }catch (ApiException e){
                e.printStackTrace();
            }

            //通过fastjson工具转换成json对象,逐层解析
            //将String类型的花名册json数据转换为Object数据对象
            JSONObject jsonObject = JSON.parseObject(huamingce2);

            //直接将花名册对象通过Object转换成Array数组格式
            JSONArray resultArray = jsonObject.getJSONArray("result");

            //new一个employeeFangDe对象
            EmployeeLzLizhiCopy employeeLzLizhiCopy = new EmployeeLzLizhiCopy();

            for (int i = 0; i<resultArray.size(); i++){
                JSONArray fieldListArray = resultArray
                        .getJSONObject(i).getJSONArray("field_list");

                String userid = resultArray.getJSONObject(i).getString("userid");
                System.out.println("员工id：" + userid);



                /*根据用户id查询用户离职信息，获取离职前的部门id以及最后工作日（离职日期），并分别同步多条数据至数据库*/
                //***获取员工的离职信息
                String lizhi = null;
                try {
                    DingTalkClient clientLZ = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/listdimission");
                    OapiSmartworkHrmEmployeeListdimissionRequest reqLZ = new OapiSmartworkHrmEmployeeListdimissionRequest();

                    //离职员工id
                    reqLZ.setUseridList(userid);

                    OapiSmartworkHrmEmployeeListdimissionResponse rspLZ = clientLZ.execute(reqLZ, dingAccessTokenService.getAccessToken());
                    lizhi = rspLZ.getBody();
                    System.out.println(rspLZ.getBody());
                } catch (ApiException e) {
                    e.printStackTrace();
                }

                JSONObject jsonObjectLizhi;
                JSONArray resultLizhi;
                String lastWorkDay = null;

                JSONArray dept_list;
//                long main_dept_id1 = 0;
                long dept_id1 = 0;
                Date date1 = null;

//                try {
                try {
                    jsonObjectLizhi = JSON.parseObject(lizhi);
                    resultLizhi = jsonObjectLizhi.getJSONArray("result");

                    lastWorkDay = resultLizhi.getJSONObject(0).getString("last_work_day");

//                    String main_dept_id = resultLizhi.getJSONObject(0).getString("main_dept_id");
//                    main_dept_id1 = Long.parseLong(main_dept_id);

                    dept_list = resultLizhi.getJSONObject(0).getJSONArray("dept_list");

                    for (int i1 = 0; i1 < dept_list.size(); i1++) {
                        String dept_id = dept_list.getJSONObject(i1).getString("dept_id");
                        dept_id1 = Long.parseLong(dept_id);


                        try {
                            //时间戳转为日期格式
                            SimpleDateFormat simpleDateFormat111 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); //24小时制
                            String timeStamp = lastWorkDay;
                            long time = Long.parseLong(timeStamp);
                            Date date = new Date();
                            date.setTime(time);
                            String timeLizhi = simpleDateFormat111.format(date);
                            System.out.println("时间戳转日期格式：" + timeLizhi);

                            //String型日期转换成Date型
                            date1 = simpleDateFormat111.parse(timeLizhi);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

//                }catch (Exception e){
//                    e.printStackTrace();
//                }

                        System.out.println("lastWorkDay：" + lastWorkDay);
                        System.out.println("main_dept_id：" + dept_id1);
                        System.out.println("Date类型最后工作日期：" + date1);

                        //***获取指定部门的所有父部门列表
                        String bumen111 = null;
                        try {
                            DingTalkClient client111 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/listparentbydept");
                            OapiV2DepartmentListparentbydeptRequest req111 = new OapiV2DepartmentListparentbydeptRequest();
                            req111.setDeptId(dept_id1);
                            OapiV2DepartmentListparentbydeptResponse rsp111 = client111.execute(req111, dingAccessTokenService.getAccessToken());
                            bumen111 = rsp111.getBody();
                            System.out.println(rsp111.getBody());
                        } catch (ApiException e) {
                            e.printStackTrace();
                        }

                        JSONObject jsonObject111;
                        JSONObject result111;
                        JSONArray parent_id_list;

                        //获取部门详情（主要用于获取部门名称）
                        String bmid111 = null;
                        String bmid222 = null;
                        String bmid333 = null;
                        String bmid444 = null;
                        String bmid555 = null;
                        String bmid666 = null;
                        String bmid777 = null;
                        String bmid888 = null;
                        String bmid999 = null;

                        long bmid1111 = 0;
                        long bmid2222 = 0;
                        long bmid3333 = 0;
                        long bmid4444 = 0;
                        long bmid5555 = 0;
                        long bmid6666 = 0;
                        long bmid7777 = 0;
                        long bmid8888 = 0;
                        long bmid9999 = 0;

                        try {
                            jsonObject111 = JSON.parseObject(bumen111);
                            result111 = jsonObject111.getJSONObject("result");
                            parent_id_list = result111.getJSONArray("parent_id_list");
                            System.out.println("初步解析处理：" + parent_id_list);


//                    for (int a1 = 0; a1<parent_id_list.size(); a1++){
//                        String stringbumen = parent_id_list.getString(a1);
//                        System.out.println("多部门列表解析：" + stringbumen);


                            //每个部门分组的部门id共有几个
                            int xx = parent_id_list.size();

                            //倒叙查询主部门及下级各部门
//                        try {
                            bmid111 = parent_id_list.getString(xx - 1);
                            System.out.println("第一个！！！！！！！！！！！！！！！！！" + bmid111);
                            bmid222 = parent_id_list.getString(xx - 2);
                            System.out.println("第二个！！！！！！！！！！！！！！！！！" + bmid222);
                            bmid333 = parent_id_list.getString(xx - 3);
                            System.out.println("第三个！！！！！！！！！！！！！！！！！" + bmid333);
                            bmid444 = parent_id_list.getString(xx - 4);
                            System.out.println("第四个！！！！！！！！！！！！！！！！！" + bmid444);
                            bmid555 = parent_id_list.getString(xx - 5);
                            System.out.println("第五个！！！！！！！！！！！！！！！！！" + bmid555);
                            bmid666 = parent_id_list.getString(xx - 6);
                            System.out.println("第六个！！！！！！！！！！！！！！！！！" + bmid666);
                            bmid777 = parent_id_list.getString(xx - 7);
                            System.out.println("第七个！！！！！！！！！！！！！！！！！" + bmid777);
                            bmid888 = parent_id_list.getString(xx - 8);
                            System.out.println("第八个！！！！！！！！！！！！！！！！！" + bmid888);
                            bmid999 = parent_id_list.getString(xx - 9);
                            System.out.println("第九个！！！！！！！！！！！！！！！！！" + bmid999);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                        try {
                            bmid1111 = Long.parseLong(bmid111);
                            System.out.println("最终解析的每个独立的部门id1：" + bmid1111);
                            bmid2222 = Long.parseLong(bmid222);
                            System.out.println("最终解析的每个独立的部门id2：" + bmid2222);
                            bmid3333 = Long.parseLong(bmid333);
                            System.out.println("最终解析的每个独立的部门id3：" + bmid3333);
                            bmid4444 = Long.parseLong(bmid444);
                            System.out.println("最终解析的每个独立的部门id4：" + bmid4444);
                            bmid5555 = Long.parseLong(bmid555);
                            System.out.println("最终解析的每个独立的部门id5：" + bmid5555);
                            bmid6666 = Long.parseLong(bmid666);
                            System.out.println("最终解析的每个独立的部门id6：" + bmid6666);
                            bmid7777 = Long.parseLong(bmid777);
                            System.out.println("最终解析的每个独立的部门id7：" + bmid7777);
                            bmid8888 = Long.parseLong(bmid888);
                            System.out.println("最终解析的每个独立的部门id8：" + bmid8888);
                            bmid9999 = Long.parseLong(bmid999);
                            System.out.println("最终解析的每个独立的部门id9：" + bmid9999);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }


                        String bumenXQ1 = null;
                        String bumenXQ2 = null;
                        String bumenXQ3 = null;
                        String bumenXQ4 = null;
                        String bumenXQ5 = null;
                        String bumenXQ6 = null;
                        String bumenXQ7 = null;
                        String bumenXQ8 = null;
                        String bumenXQ9 = null;

                        String BMname1 = null;
                        String BMname2 = null;
                        String BMname3 = null;
                        String BMname4 = null;
                        String BMname5 = null;
                        String BMname6 = null;
                        String BMname7 = null;
                        String BMname8 = null;
                        String BMname9 = null;


                        /*👇👇👇👇👇👇另一种写法，优化方案，待测试👇👇👇👇👇👇*/

                        /*👆👆👆👆👆👆另一种写法，优化方案，待测试👆👆👆👆👆👆*/


                        System.out.println("bmid111：" + bmid111);
                        System.out.println("bmid1111：" + bmid1111);
                        if (bmid111 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid1111);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ1 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ1);
                            System.out.println("初步解析处理（部门1详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname1 = result222.getString("name");
                            System.out.println("部门1名称：" + BMname1);
                        } else {
                            BMname1 = "上海律正企业管理有限公司";
                        }

                        System.out.println("bmid222：" + bmid222);
                        System.out.println("bmid2222：" + bmid2222);
                        if (bmid222 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid2222);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ2 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ2);
                            System.out.println("初步解析处理（部门2详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname2 = result222.getString("name");
                            System.out.println("部门2名称：" + BMname2);
                        } else {
                            BMname2 = "-";
                        }

                        System.out.println("bmid333：" + bmid333);
                        System.out.println("bmid3333：" + bmid3333);
                        if (bmid333 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid3333);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ3 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ3);
                            System.out.println("初步解析处理（部门3详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname3 = result222.getString("name");
                            System.out.println("部门3名称：" + BMname3);
                        } else {
                            BMname3 = "-";
                        }

                        System.out.println("bmid444：" + bmid444);
                        System.out.println("bmid4444：" + bmid4444);
                        if (bmid444 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid4444);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ4 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ4);
                            System.out.println("初步解析处理（部门4详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname4 = result222.getString("name");
                            System.out.println("部门4名称：" + BMname4);
                        } else {
                            BMname4 = "-";
                        }

                        System.out.println("bmid555：" + bmid555);
                        System.out.println("bmid5555：" + bmid5555);
                        if (bmid555 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid5555);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ5 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ5);
                            System.out.println("初步解析处理（部门5详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname5 = result222.getString("name");
                            System.out.println("部门5名称：" + BMname5);
                        } else {
                            BMname5 = "-";
                        }

                        System.out.println("bmid666：" + bmid666);
                        System.out.println("bmid6666：" + bmid6666);
                        if (bmid666 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid6666);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ6 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ6);
                            System.out.println("初步解析处理（部门6详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname6 = result222.getString("name");
                            System.out.println("部门6名称：" + BMname6);
                        } else {
                            BMname6 = "-";
                        }

                        System.out.println("bmid777：" + bmid777);
                        System.out.println("bmid7777：" + bmid7777);
                        if (bmid777 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid7777);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ7 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ7);
                            System.out.println("初步解析处理（部门7详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname7 = result222.getString("name");
                            System.out.println("部门7名称：" + BMname7);
                        } else {
                            BMname7 = "-";
                        }

                        System.out.println("bmid888：" + bmid888);
                        System.out.println("bmid8888：" + bmid8888);
                        if (bmid888 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid8888);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ8 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ8);
                            System.out.println("初步解析处理（部门8详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname8 = result222.getString("name");
                            System.out.println("部门8名称：" + BMname8);
                        } else {
                            BMname8 = "-";
                        }

                        System.out.println("bmid999：" + bmid999);
                        System.out.println("bmid9999：" + bmid9999);
                        if (bmid999 != null) {
                            try {
                                DingTalkClient client222 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
                                OapiV2DepartmentGetRequest req222 = new OapiV2DepartmentGetRequest();

                                //部门id
                                req222.setDeptId(bmid9999);

                                OapiV2DepartmentGetResponse rsp222 = client222.execute(req222, dingAccessTokenService.getAccessToken());
                                bumenXQ9 = rsp222.getBody();
                                System.out.println(rsp222.getBody());
                            } catch (ApiException e) {
                                e.printStackTrace();
                            }

                            //解析出来部门名称
                            JSONObject jsonObject222 = JSON.parseObject(bumenXQ9);
                            System.out.println("初步解析处理（部门9详情）：" + jsonObject222);

                            JSONObject result222 = jsonObject222.getJSONObject("result");
                            BMname9 = result222.getString("name");
                            System.out.println("部门9名称：" + BMname9);
                        } else {
                            BMname9 = "-";
                        }


                        //TODO 每组部门id都插入一条员工信息到数据库
                        //将result的每个对象的id放入employee实体类的id字段中
                        employeeLzLizhiCopy.setId(userid);
                        //最后工作日期（目前放在入职日期字段中）
                        employeeLzLizhiCopy.setSys00ConfirmJoinTime(date1);

                        //TODO 循环插入部门分组不同层级的部门到数据库各个部门层级字段中
                        employeeLzLizhiCopy.setBmid1("1");
                        employeeLzLizhiCopy.setBmmc1(BMname1);

                        employeeLzLizhiCopy.setBmid2(bmid222);
                        employeeLzLizhiCopy.setBmmc2(BMname2);

                        employeeLzLizhiCopy.setBmid3(bmid333);
                        employeeLzLizhiCopy.setBmmc3(BMname3);

                        employeeLzLizhiCopy.setBmid4(bmid444);
                        employeeLzLizhiCopy.setBmmc4(BMname4);

                        employeeLzLizhiCopy.setBmid5(bmid555);
                        employeeLzLizhiCopy.setBmmc5(BMname5);

                        employeeLzLizhiCopy.setBmid6(bmid666);
                        employeeLzLizhiCopy.setBmmc6(BMname6);

                        employeeLzLizhiCopy.setBmid7(bmid777);
                        employeeLzLizhiCopy.setBmmc7(BMname7);

                        employeeLzLizhiCopy.setBmid8(bmid888);
                        employeeLzLizhiCopy.setBmmc8(BMname8);

                        employeeLzLizhiCopy.setBmid9(bmid999);
                        employeeLzLizhiCopy.setBmmc9(BMname9);

                        for (int a = 0; a < fieldListArray.size(); a++) {
                            String fieldCode = fieldListArray
                                    .getJSONObject(a)
                                    .getString("field_code");

                            switch (fieldCode) {
                                //姓名
                                case "sys00-name":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***《《《姓名》》》***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        //放入employee表的姓名字段中
                                        employeeLzLizhiCopy.setSys00Name(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        //如果没有则放入空值
                                        employeeLzLizhiCopy.setSys00Name("");
                                    }
                                    break;

                                //职位
                                case "sys00-position":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***职位***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setSys00Position(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setSys00Position("");
                                    }
                                    break;

                                //性别
                                case "sys02-sexType":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***性别***-->" + fieldListArray.getJSONObject(a).getString("value"));
//                            String sex = fieldListArray.getJSONObject(a).getInteger("value") == 0 ?"男":"女";
//                            employee.setSys02SexType(sex);
                                        employeeLzLizhiCopy.setSys02SexType(fieldListArray.getJSONObject(a).getInteger("value"));
                                    } else {
                                        employeeLzLizhiCopy.setSys02SexType(null);
                                    }
                                    break;

                                //员工类型
                                case "sys01-employeeType":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***员工类型***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setSys01EmployeeType(fieldListArray.getJSONObject(a).getInteger("value"));
                                    } else {
                                        employeeLzLizhiCopy.setSys01EmployeeType(null);
                                    }
                                    break;

                                //员工状态
                                case "sys01-employeeStatus":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***员工状态***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setSys01EmployeeStatus(fieldListArray.getJSONObject(a).getInteger("value"));
                                    } else {
                                        employeeLzLizhiCopy.setSys01EmployeeStatus(null);
                                    }
                                    break;

                                //***新增展示字段***
                                //直属主管
                                case "sys00-reportManager":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***直属主管***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setZhishuzhuguan(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setZhishuzhuguan(null);
                                    }
                                    break;

                                //入职时间
                                case "sys00-confirmJoinTime":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***入职时间***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setRuzhishijian(fieldListArray.getJSONObject(a).getDate("value"));
                                    } else {
                                        employeeLzLizhiCopy.setRuzhishijian(null);
                                    }
                                    break;

                                //身份证号码
                                case "sys02-certNo":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***身份证号码***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setShenfenzheng(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setShenfenzheng(null);
                                    }
                                    break;

                                //电话号码
                                case "sys00-mobile":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***电话号码***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setShenfenzheng(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setShenfenzheng(null);
                                    }
                                    break;

                                //银行卡号
                                case "sys04-bankAccountNo":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***银行卡号***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setYinhangkahao(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setYinhangkahao(null);
                                    }
                                    break;

                                //***新增展示字段***
                                //入职渠道
                                case "89d91b67-dbae-4439-b451-abb73281b47b":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***入职渠道***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setRuzhiqudao(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setRuzhiqudao(null);
                                    }
                                    break;

                                //工号
                                case "sys00-jobNumber":
                                    if (fieldListArray.getJSONObject(a).getString("value") != null) {
                                        System.out.println("***工号***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                        employeeLzLizhiCopy.setGonghao(fieldListArray.getJSONObject(a).getString("value"));
                                    } else {
                                        employeeLzLizhiCopy.setGonghao(null);
                                    }
                                    break;
                            }
                        }
                        employeeLzLizhiCopyMapper.insert(employeeLzLizhiCopy);
                    }
                }catch (Exception e){
                    e.printStackTrace();
                }


                        System.out.println("-------------------------分组分割线-------------------------");

                    }
                    /*根据用户id查询用户离职信息，获取离职前的部门id以及最后工作日（离职日期），并分别同步多条数据至数据库*/

//                }catch (Exception e){
//                    e.printStackTrace();
//                }
//            }


            if (result1.getString("next_cursor") != null || result1.getString("data_list") != "") {

                offset = offset + size;

            }

        } while (result1.getString("next_cursor") != null);



        //清空employee_lz最终展示表数据
        removeEmployeeLzLizhi();

        //TODO 将数据库中已经同步完成的employee_lz的数据1：1复制插入到另一张表中
        QueryWrapper<EmployeeLzLizhiCopy> employeeLzLizhiCopyQueryWrapper = new QueryWrapper<>();
        List<EmployeeLzLizhiCopy> employeeLzLizhiCopyList = employeeLzLizhiCopyMapper.selectList(employeeLzLizhiCopyQueryWrapper);
//        System.out.println("初步同步数据的表：employeeLzLizhiCopy" + employeeLzLizhiCopyList);

        //最终展示的表（待插入数据的表）
        EmployeeLzLizhi employeeLzLizhi = new EmployeeLzLizhi();

        //将有数据的表数据插入无数据的表对应的字段中
        for (int z = 0; z<employeeLzLizhiCopyList.size(); z++){
            employeeLzLizhi.setId(employeeLzLizhiCopyList.get(z).getId());
            employeeLzLizhi.setSys00Name(employeeLzLizhiCopyList.get(z).getSys00Name());
            employeeLzLizhi.setSys00ConfirmJoinTime(employeeLzLizhiCopyList.get(z).getSys00ConfirmJoinTime());
            employeeLzLizhi.setSys00Position(employeeLzLizhiCopyList.get(z).getSys00Position());
            employeeLzLizhi.setSys02SexType(employeeLzLizhiCopyList.get(z).getSys02SexType());
            employeeLzLizhi.setSys01EmployeeType(employeeLzLizhiCopyList.get(z).getSys01EmployeeType());
            employeeLzLizhi.setSys01EmployeeStatus(employeeLzLizhiCopyList.get(z).getSys01EmployeeStatus());

            employeeLzLizhi.setZhishuzhuguan(employeeLzLizhiCopyList.get(z).getZhishuzhuguan());
            employeeLzLizhi.setRuzhishijian(employeeLzLizhiCopyList.get(z).getRuzhishijian());
            employeeLzLizhi.setShenfenzheng(employeeLzLizhiCopyList.get(z).getShenfenzheng());
            employeeLzLizhi.setDianhuahaoma(employeeLzLizhiCopyList.get(z).getDianhuahaoma());
            employeeLzLizhi.setYinhangkahao(employeeLzLizhiCopyList.get(z).getYinhangkahao());
            employeeLzLizhi.setRuzhiqudao(employeeLzLizhiCopyList.get(z).getRuzhiqudao());
            employeeLzLizhi.setGonghao(employeeLzLizhiCopyList.get(z).getGonghao());

            employeeLzLizhi.setBmid1(employeeLzLizhiCopyList.get(z).getBmid1());
            employeeLzLizhi.setBmmc1(employeeLzLizhiCopyList.get(z).getBmmc1());

            employeeLzLizhi.setBmid2(employeeLzLizhiCopyList.get(z).getBmid2());
            employeeLzLizhi.setBmmc2(employeeLzLizhiCopyList.get(z).getBmmc2());

            employeeLzLizhi.setBmid3(employeeLzLizhiCopyList.get(z).getBmid3());
            employeeLzLizhi.setBmmc3(employeeLzLizhiCopyList.get(z).getBmmc3());

            employeeLzLizhi.setBmid4(employeeLzLizhiCopyList.get(z).getBmid4());
            employeeLzLizhi.setBmmc4(employeeLzLizhiCopyList.get(z).getBmmc4());

            employeeLzLizhi.setBmid5(employeeLzLizhiCopyList.get(z).getBmid5());
            employeeLzLizhi.setBmmc5(employeeLzLizhiCopyList.get(z).getBmmc5());

            employeeLzLizhi.setBmid6(employeeLzLizhiCopyList.get(z).getBmid6());
            employeeLzLizhi.setBmmc6(employeeLzLizhiCopyList.get(z).getBmmc6());

            employeeLzLizhi.setBmid7(employeeLzLizhiCopyList.get(z).getBmid7());
            employeeLzLizhi.setBmmc7(employeeLzLizhiCopyList.get(z).getBmmc7());

            employeeLzLizhi.setBmid8(employeeLzLizhiCopyList.get(z).getBmid8());
            employeeLzLizhi.setBmmc8(employeeLzLizhiCopyList.get(z).getBmmc8());

            employeeLzLizhi.setBmid9(employeeLzLizhiCopyList.get(z).getBmid9());
            employeeLzLizhi.setBmmc9(employeeLzLizhiCopyList.get(z).getBmmc9());

            employeeLzLizhiMapper.insert(employeeLzLizhi);
        }

        return "同步律政【离职数据】成功！";

    }
}
